#!/usr/bin/perl
use Mysql;

#    RingWorld SQL v1.9 - webring management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Variables Section
open (F, "<rworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

######################################################################
# Main Section                                                       #
######################################################################
# Get data
if ($ENV{CONTENT_LENGTH}>0){sysread(STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$data{$field}=$value;
	}
}
@data=();
$text=$data{text};
$text=~s/\+/ /g;
$text=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
$start=$data{start};
$start=0 unless ($start);

if ($data{type} eq "ring")
{
	$sth=$dbh->query("LOCK TABLES rw_users READ, rw_rings READ, rw_sites READ") if ($locktables);
	$sth=$dbh->query("SELECT rw_rings.rid,rname,rdescr,sum(hits) FROM rw_rings,rw_sites,rw_users WHERE (status=1 AND (rname LIKE '%$text%' OR rdescr LIKE '%$text%') AND rw_rings.rid=rw_sites.rid AND rw_rings.uid=rw_users.uid) GROUP BY rw_rings.rid ORDER BY rname");
	while (($rid,$rname,$rdescr,$hits)=$sth->fetchrow)
	{
		$fullrn=qq~<a href="$cgi/rwgetnfo.pl?Webring=$rid" target="_blank">$rname ($hits hits)</a>~;
		push (@data,"$hits\t$fullrn\t$rdescr");
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	@data=sort ({$b<=>$a} @data);
	push (@footer,"<table width=\"100%\" border=0><tr>");
	$icount=scalar(@data);
	if (scalar (@data)>20)
	{
		if ($start>0)
		{
			$pstart=$start-1;
			push(@footer,"<td width=\"15%\" align=\"center\"><font size=2><a href=\"$cgi/rwsearch.pl?text=$data{text}&type=$data{type}&start=$pstart\">PREVIOUS</a></font></td>");
		}
		else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
		push(@footer,"<td width=\"70%\" align=\"center\"><font size=2><b>$icount webrings found</b></font></td>");
		if ($start*20+20<scalar(@data))
		{
			$nstart=$start+1;
			push(@footer,"<td width=\"15%\" align=\"center\"><font size=2><a href=\"$cgi/rwsearch.pl?text=$data{text}&type=$data{type}&start=$nstart\">NEXT</a></font></td>");
		}
		else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
	}
	else {push(@footer,"<td width=\"100%\" align=\"center\"><font size=2><b>$icount webrings found</b></font></td>");}
	push (@footer,"</tr></table>");
	if ($start*20+20>scalar(@data))
	{
		$i=$start*20;
		while($i<scalar(@data))
		{
			$y=$i+1;
			($count,$title,$uurl)=split("\t",$data[$i]);
			$uurl=~s/$text/\<b\>$text\<\/b\>/g if ($text);
			push(@result,"$y. <font face=\"Arial\" size=\"2\">$title <br><font size=2 color=white>$uurl</font></font></a><br><br>\n");
			$i++;
		}
	}
	else
	{
		$i=$start*20;
		$last=$i+20;
		while($i<$last)
		{
			$y=$i+1;
			($count,$title,$uurl)=split("\t",$data[$i]);
			$uurl=~s/$text/\<b\>$text\<\/b\>/g if ($text);
			push(@result,"$y. <font face=\"Arial\" size=\"2\">$title <br><font size=2 color=white>$uurl</font></font></a><br><br>\n");
			$i++;
		}
	}
	if (!@result)
	{
		push(@result,"<font size=2>Nothing found</font>");
	}
	# Print Results
	&closedb;
	open (F,"<$rwpath/template/search.tpl");
	@html=<F>;
	close (F);
	$html=join("",@html);
	$html="print qq~$html~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $html;
}
else
{
	$sth=$dbh->query("LOCK TABLES rw_users READ, rw_rings READ, rw_sites READ") if ($locktables);
	$sth=$dbh->query("SELECT sname,surl,sdescr,rw_sites.rid,rname,hits FROM rw_rings,rw_sites,rw_users WHERE (status=1 AND (sname LIKE '%$text%' OR sdescr LIKE '%$text%') AND rw_sites.rid=rw_rings.rid AND rw_sites.uid=rw_users.uid) ORDER BY sname");
	while (($sname,$surl,$sdescr,$rid,$rname,$hits)=$sth->fetchrow)
	{
		$fullrn=qq~<br>Webring: <a href="$cgi/rwgetnfo.pl?Webring=$rid" target="_blank">$rname</a>~;
		push (@data,"$hits\t$sname\t$surl\t$fullrn\t$sdescr");
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	@data=sort ({$b<=>$a} @data);
	$icount=scalar(@data);
	push (@footer,"<table width=\"100%\" border=0><tr>");
	if (scalar (@data)>20)
	{
		if ($start>0)
		{
			$pstart=$start-1;
			push(@footer,"<td width=\"15%\" align=\"center\"><font size=2><a href=\"$cgi/rwsearch.pl?text=$data{text}&type=$data{type}&start=$pstart\">PREVIOUS</a></font></td>");
		}
		else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
		push(@footer,"<td width=\"70%\" align=\"center\"><font size=2><b>$icount websites found</b></font></td>");
		if ($start*20+20<scalar(@data))
		{
			$nstart=$start+1;
			push(@footer,"<td width=\"15%\" align=\"center\"><font size=2><a href=\"$cgi/rwsearch.pl?text=$data{text}&type=$data{type}&start=$nstart\">NEXT</a></font></td>");
		}
		else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
	}
	else {push(@footer,"<td width=\"100%\" align=\"center\"><font size=2><b>$icount websites found</b></font></td>");}
	push (@footer,"</tr></table>");
	if ($start*20+20>scalar(@data))
	{
		$i=$start*20;
		while($i<scalar(@data))
		{
			$y=$i+1;
			($count,$tit,$uurl,$fullrn,$desc)=split("\t",$data[$i]);
			$desc=~s/$text/\<b\>$text\<\/b\>/g if ($text);
			push(@result,"$y. <font face=\"Arial\" size=\"2\"><a href=\"$uurl\" target=\"_blank\">$tit ($count hits)</a>$fullrn<br><font size=2 color=white>$desc</font></font></a><br><br>\n");
			$i++;
		}
	}
	else
	{
		$i=$start*20;
		$last=$i+20;
		while($i<$last)
		{
			$y=$i+1;
			($count,$tit,$uurl,$fullrn,$desc)=split("\t",$data[$i]);
			$desc=~s/$text/\<b\>$text\<\/b\>/g if ($text);
			push(@result,"$y. <font face=\"Arial\" size=\"2\"><a href=\"$uurl\" target=\"_blank\">$tit ($count hits)</a>$fullrn<br><font size=2 color=white>$desc</font></font></a><br><br>\n");
			$i++;
		}
	}
	if (!@result)
	{
		push(@result,"<li>Nothing found</li>");
	}
	# Print Results
	&closedb;
	open (F,"<$rwpath/template/search.tpl");
	@html=<F>;
	close (F);
	$html=join("",@html);
	$html="print qq~$html~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $html;
}
sub closedb
{
$sth="";
$dbh="";
}
